"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const optionsManager = require("./managers/options");
const scandirProvider = require("./providers/scandir");
/**
 * Asynchronous API.
 */
function scandir(path, opts) {
    return new Promise((resolve, reject) => {
        return scandirProvider.async(path, optionsManager.prepare(opts), (err, stats) => err ? reject(err) : resolve(stats));
    });
}
exports.scandir = scandir;
function scandirCallback(path, optsOrCallback, callback) {
    if (typeof optsOrCallback === 'function') {
        callback = optsOrCallback; /* tslint:disable-line: no-parameter-reassignment */
        optsOrCallback = undefined; /* tslint:disable-line: no-parameter-reassignment */
    }
    if (typeof callback === 'undefined') {
        throw new TypeError('The "callback" argument must be of type Function.');
    }
    scandirProvider.async(path, optionsManager.prepare(optsOrCallback), callback);
}
exports.scandirCallback = scandirCallback;
/**
 * Synchronous API.
 */
function scandirSync(path, opts) {
    return scandirProvider.sync(path, optionsManager.prepare(opts));
}
exports.scandirSync = scandirSync;
