import { FileSystemAdapter } from '../adapters/fs';
import { DirEntry } from '../types/entry';
export declare type PreFilterFunction = (name: string, path: string) => boolean;
export declare type FilterFunction = (entry: DirEntry) => boolean;
export declare type SortFunction = (a: DirEntry, b: DirEntry) => number;
export interface Options {
    fs?: Partial<FileSystemAdapter>;
    includeRootDirectory?: boolean;
    stats?: boolean;
    followSymlinks?: boolean;
    throwErrorOnBrokenSymlinks?: boolean;
    preFilter?: PreFilterFunction | null;
    filter?: FilterFunction | null;
    sort?: SortFunction | null;
}
export declare type StrictOptions = {
    fs: FileSystemAdapter;
} & Required<Options>;
export declare function prepare(opts?: Options): StrictOptions;
//# sourceMappingURL=options.d.ts.map